Attribute VB_Name = "mSubclass"
Option Explicit

Public VBInstance                   As VBIDE.VBE 'this has the instantiated application object

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Const IDX_WINDOWPROC        As Long = -4

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Private Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Const PropName              As String = "Hooked"

Public Declare Function GetCursorPos Lib "user32" (lpPoint As Point) As Long
Private Type Point
    X As Long
    Y As Long
End Type

Private Enum ArrayIndexes
    idxCompoName = 0
    idxMemberName = 1
    idxMemberScope = 2
End Enum

Public CursorPos                    As Point

Private KeyWords                    As Collection
Private CodeMembers                 As Collection

Private Const WM_SETFOCUS           As Long = 7
Private Const WM_KILLFOCUS          As Long = 8
Private Const WM_KEYDOWN            As Long = &H100
Private Const WM_CHAR               As Long = &H102
Private Const WM_MOUSEWHEEL         As Long = &H20A
Private Const WM_MDIACTIVATE        As Long = &H222

Private hWndMDIClient               As Long
Private hWndCodePane                As Long
Private UserTypedCode               As Boolean

'Send Mail
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL         As Long = 1
Private Const SE_NO_ERROR           As Long = 33 'Values below 33 are error returns

'Registry
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType, lpData As Any, lpcbData As Long) As Long
Private Declare Sub RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long)
Private Const KEY_QUERY_VALUE       As Long = 1
Private Const REG_OPTION_RESERVED   As Long = 0
Private Const ERROR_NONE            As Long = 0

'Registry scroll setting access keys...
Private Const HKEY_CURRENT_USER     As Long = &H80000001
Private Const DesktopSettings       As String = "Control Panel\Desktop"
Private Const SmoothScroll          As String = "SmoothScroll"
Private Const WheelScrollLines      As String = "WheelScrollLines"

'...and our own settings...
Public Const sOptions               As String = "Options"
Public Const sLines                 As String = "Lines"
Public Const sMode                  As String = "Mode"
Public Const sSmooth                As String = "Smooth"
Public Const sInstant               As String = "Instant"
Public Const sAutoComplete          As String = "AutoComplete"
Public Const sNoisy                 As String = "Noisy"
Public Const sTriggerLength         As String = "TriggerLength"
Public Const sOn                    As String = "On"
Public Const sOff                   As String = "Off"

'..and finally what we got (or didn't get) from the Registry or from our own options
Public LinesToScroll                As String
Public Smooth                       As Long
Public AutoComplete                 As Boolean
Public Noisy                        As Boolean
Public TriggerLength                As Long 'the minimum length of word fragment to trigger autocomplete

'- - - - - - - - - - - - - - - - - - - - - - - - modify both values to correspond- - - - -
Public Const opHpCapt               As String = "Half a &Page"
Private Const ScrollFraction        As Single = 1 / 2 'fraction of page to scroll
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Private Function CodePaneProc(ByVal hWnd As Long, ByVal nMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

  'Window Procedure for the active IDE Codepane

  Dim i             As Long
  Dim j             As Long
  Dim LineStartSel  As Long
  Dim WordStartsAt  As Long
  Dim LenWord       As Long
  Dim LenRepl       As Long
  Dim OriginalLine  As String
  Dim CurrentWord   As String
  Dim Temp          As String
  Dim Repl          As String
  Dim Entry         As Variant

    CodePaneProc = CallWindowProc(GetProp(hWnd, PropName), hWnd, nMsg, wParam, lParam)
    If AutoComplete Then
        Select Case nMsg
          Case WM_KEYDOWN
            Select Case wParam
              Case vbKeyReturn, vbKeyUp, vbKeyDown, vbKeyPageUp, vbKeyPageDown 'the user has just left a line
                If UserTypedCode Then 'and has typed some code into that line
                    RefreshMembers 'so refresh our members collection
                    UserTypedCode = False
                End If
            End Select
          Case WM_CHAR 'the user has typed a char
            UserTypedCode = False 'my be set to true later
            Select Case wParam
              Case vbKeyBack 'would be kinda undecent to autocomplete if the user is backspace-deleting
                'do nothing
              Case Else
                With VBInstance.ActiveCodePane
                    .GetSelection LineStartSel, i, j, j 'where's the caret
                    OriginalLine = .CodeModule.Lines(LineStartSel, 1) 'get the line the user is currently typing into
                    CurrentWord = Replace$(Replace$(Replace$(Replace$(Replace$(Replace$(Replace$(Replace$(Replace$(Replace$(Replace$(Replace$(Replace$(OriginalLine, "(", " "), ")", " "), ",", " "), ":", " "), "=", " "), "<", " "), ">", " "), "+", " "), "-", " "), "*", " "), "/", " "), "\", " "), "&", " ")
                    If Len(OriginalLine) And i > 1 Then 'there is something in this line - have a closer look
                        WordStartsAt = InStrRev(CurrentWord, " ", i - 1) + 1
                        If IsInCode(CurrentWord, WordStartsAt) Then 'this is part of the coding (not comment nor literal)
                            UserTypedCode = True
                            CurrentWord = Mid$(CurrentWord, WordStartsAt) 'extract the word-fragment the user is typing right now
                            i = InStr(CurrentWord, " ")
                            If i Then
                                CurrentWord = Left$(CurrentWord, i - 1)
                            End If
                            CurrentWord = LCase$(Trim$(CurrentWord)) 'isolated word fragment to lower case
                            LenWord = Len(CurrentWord)
                            If LenWord >= TriggerLength Then 'don't harrass the user with too short words
                                If LineStartSel > .CodeModule.CountOfDeclarationLines Then 'search the Members Collection
                                    For Each Entry In CodeMembers 'Entry is a Variant of Type Array
                                        If Entry(idxCompoName) = .CodeModule.Parent.Name Then
                                            i = 0
                                          Else 'NOT ENTRY(IDXCOMPONAME)...
                                            i = vbext_Private 'i has forbidden scope
                                        End If
                                        If Entry(idxMemberScope) <> i Then
                                            Temp = CStr(Entry(idxMemberName))
                                            LenRepl = Len(Temp)
                                            If LenWord < LenRepl Then 'user has not yet finished typing the word so offer autocomplete
                                                If CurrentWord = LCase$(Left$(Temp, LenWord)) Then
                                                    Repl = Temp
                                                    Exit For '>---> Next
                                                End If
                                            End If
                                        End If
                                    Next Entry
                                End If
                                If Len(Repl) = 0 Then 'no Repl found yet, so search the KeyWords Collection
                                    For Each Entry In KeyWords
                                        Temp = CStr(Entry) 'here Entry is a Variant of Type String
                                        LenRepl = Len(Temp)
                                        If LenWord < LenRepl Then 'user has not yet finished typing the word so offer autocomplete
                                            If CurrentWord = LCase$(Left$(Temp, LenWord)) Then
                                                Repl = Temp
                                                Exit For '>---> Next
                                            End If
                                        End If
                                    Next Entry
                                End If
                                If Len(Repl) Then
                                    OriginalLine = Replace$(Replace$(Replace$(Left$(OriginalLine, WordStartsAt - 1) & Repl & Mid$(OriginalLine, WordStartsAt + LenWord), "><", "<>"), "=<", "<="), "=>", ">=")
                                    With .CodeModule
                                        .ReplaceLine LineStartSel, OriginalLine
                                        Temp = .Lines(LineStartSel, 1) 'get line back to see whether VB has expanded or compacted the line and adjust selection accordingly
                                    End With '.CODEMODULE
                                    i = 1
                                    j = 1
                                    Do
                                        Select Case " "
                                          Case Mid$(OriginalLine, i, 1)
                                            i = i + 1
                                          Case Mid$(Temp, j, 1)
                                            j = j + 1
                                          Case Else
                                            i = i + 1
                                            j = j + 1
                                        End Select
                                    Loop Until i = WordStartsAt + LenRepl Or j = WordStartsAt + LenRepl
                                    i = j - i
                                    .SetSelection LineStartSel, WordStartsAt + LenRepl + i, LineStartSel, WordStartsAt + LenWord + i
                                    If Noisy Then
                                        Beep
                                    End If
                                End If
                            End If
                        End If
                    End If
                End With 'VBINSTANCE.ACTIVECODEPANE
            End Select
        End Select
    End If

End Function

Public Sub GetScrollSettings()

  Dim RegHandle     As Long
  Dim DataType      As Long
  Dim DataLength    As Long

    If RegOpenKeyEx(HKEY_CURRENT_USER, DesktopSettings, REG_OPTION_RESERVED, KEY_QUERY_VALUE, RegHandle) = ERROR_NONE Then
        LinesToScroll = String$(4, 0)
        DataLength = Len(LinesToScroll)
        If RegQueryValueEx(RegHandle, WheelScrollLines, REG_OPTION_RESERVED, DataType, ByVal LinesToScroll, DataLength) = ERROR_NONE Then
            LinesToScroll = Left$(LinesToScroll, DataLength + (Asc(Mid$(LinesToScroll, DataLength, 1)) = 0))
            If Not IsNumeric(LinesToScroll) Then 'default
                LinesToScroll = "-2"
            End If
          Else 'default'NOT REGQUERYVALUEEX(REGHANDLE,...
            LinesToScroll = "-2"
        End If
        DataLength = Len(Smooth)
        If RegQueryValueEx(RegHandle, SmoothScroll, REG_OPTION_RESERVED, DataType, Smooth, DataLength) = ERROR_NONE Then
            Smooth = CBool(Smooth)
          Else 'default'NOT REGQUERYVALUEEX(REGHANDLE,...
            Smooth = True
        End If
        RegCloseKey RegHandle
      Else 'default'NOT REGOPENKEYEX(HKEY_CURRENT_USER,...
        LinesToScroll = "-2"
        Smooth = True
    End If
    With App
        LinesToScroll = GetSetting(.Title, sOptions, sLines, LinesToScroll)
        Smooth = (GetSetting(.Title, sOptions, sMode, IIf(Smooth, sSmooth, sInstant)) = sSmooth)
        AutoComplete = (GetSetting(.Title, sOptions, sAutoComplete, sOn) = sOn)
        Noisy = (GetSetting(.Title, sOptions, sNoisy, sOn) = sOn)
        TriggerLength = GetSetting(.Title, sOptions, sTriggerLength, 3)
    End With 'APP

End Sub

Private Sub HookCodePane()

    On Error Resume Next
        With VBInstance
            If .ActiveWindow Is .ActiveCodePane.Window Then
                hWndCodePane = FindWindowEx(hWndMDIClient, 0, "VbaWindow", .ActiveWindow.Caption)
                If hWndCodePane Then
                    If GetProp(hWndCodePane, PropName) = 0 Then
                        SetProp hWndCodePane, PropName, GetWindowLong(hWndCodePane, IDX_WINDOWPROC)
                        SetWindowLong hWndCodePane, IDX_WINDOWPROC, AddressOf CodePaneProc
                    End If
                End If
            End If
        End With 'VBINSTANCE
        RefreshMembers
    On Error GoTo 0

End Sub

Public Sub HookMDIClient()

    On Error Resume Next
        hWndMDIClient = FindWindowEx(VBInstance.MainWindow.hWnd, 0, "MDIClient", vbNullString)
        If hWndMDIClient Then
            If GetProp(hWndMDIClient, PropName) = 0 Then
                SetProp hWndMDIClient, PropName, GetWindowLong(hWndMDIClient, IDX_WINDOWPROC)
                SetWindowLong hWndMDIClient, IDX_WINDOWPROC, AddressOf MDIClientProc
            End If
            HookCodePane
        End If
    On Error GoTo 0

End Sub

Private Function IsInCode(Line As String, Posn As Long) As Boolean

  'this checks that the current word is not in a literal or a comment
  'and is not preceded by the As keyword

  Dim p             As Long
  Dim l             As String
  Dim Cnt           As Long

    IsInCode = True
    p = Posn
    Do Until p = 0
        p = InStrRev(Line, """", p)
        If p Then
            Cnt = Cnt + 1 'count the number of quotes preceeding the current word..
            p = p - 1     '..if this is odd we're in a literal
        End If
    Loop
    If Cnt And 1 Then 'odd - we're inside a literal
        IsInCode = False
      Else 'NOT CNT...
        'see if an Apostophe or Rem, or the As keyword preceeds the current word
        p = InStrRev(Line, "'", Posn)
        If p = 0 Then
            l = " " & Line
            p = InStrRev(l, " rem ", Posn, vbTextCompare)
        End If
        If p = 0 Then
            p = InStrRev(l, " as ", Posn, vbTextCompare)
        End If
        If p Then
            IsInCode = False
        End If
    End If

End Function

Public Sub LoadKeywords()

    Set KeyWords = New Collection

    'if you feel like modifying or adding to this list of keywords - go ahead, it's not complete
    With KeyWords
        .Add "AppActivate"
        .Add "Array("
        .Add "CBool("
        .Add "CByte("
        .Add "CDate("
        .Add "ChDir"
        .Add "ChDrive"
        .Add "Choose("
        .Add "Circle"
        .Add "Clipboard"
        .Add "Close"
        .Add "Command$"
        .Add "CommitTrans"
        .Add "CompactDatabase"
        .Add "Const"
        .Add "CreateObject("
        .Add "CurDir"
        .Add "Database"
        .Add "DateAdd("
        .Add "DateDiff("
        .Add "DatePart("
        .Add "DateSerial("
        .Add "DateValue("
        .Add "Debug"
        .Add "Declare Funtion"
        .Add "DeleteSetting"
        .Add "Document"
        .Add "DoEvents"
        .Add "Environ$"
        .Add "Erase"
        .Add "FileAttr("
        .Add "FileCopy"
        .Add "FileDateTime("
        .Add "FileLen("
        .Add "Format$("
        .Add "FreeFile"
        .Add "FreeLocks"
        .Add "Friend"
        .Add "Function"
        .Add "GetAllSettings("
        .Add "GetAttr("
        .Add "GetObject("
        .Add "GetSetting("
        .Add "Hour("
        .Add "Input #"
        .Add "InputBox("
        .Add "Instr("
        .Add "InstrRev("
        .Add "IsArray("
        .Add "IsDate("
        .Add "IsEmpty("
        .Add "IsError("
        .Add "IsMissing("
        .Add "IsNull("
        .Add "IsNumeric("
        .Add "IsObject("
        .Add "LBound("
        .Add "LCase$("
        .Add "Left$("
        .Add "Line Input #"
        .Add "LoadPicture("
        .Add "LoadResData("
        .Add "LoadResPicture("
        .Add "LoadResString("
        .Add "LTrim$("
        .Add "Mid$("
        .Add "Minute("
        .Add "Month("
        .Add "MsgBox"
        .Add "Partition("
        .Add "Print #"
        .Add "Private"
        .Add "Property"
        .Add "Public"
        .Add "QBColor("
        .Add "Randomize"
        .Add "Redim"
        .Add "Replace$("
        .Add "Reset"
        .Add "Resume"
        .Add "Right$("
        .Add "Rollback"
        .Add "RTrim$("
        .Add "SavePicture"
        .Add "SaveSetting"
        .Add "Screen"
        .Add "Second("
        .Add "Seek #"
        .Add "Select Case"
        .Add "SendKeys"
        .Add "SetAttr"
        .Add "SetDataAccessOption"
        .Add "SetDefaultWorkpace"
        .Add "Space$("
        .Add "Static"
        .Add "String$("
        .Add "Switch("
        .Add "Timer"
        .Add "TimeValue("
        .Add "Trim$("
        .Add "TypeName("
        .Add "UBound("
        .Add "UCase$("
        .Add "Unload"
        .Add "Until"
        .Add "VarType("
        .Add "Weekday("
        .Add "While"
        .Add "Write #"
        .Add "Year("
    End With 'KEYWORDS

End Sub

Private Function MDIClientProc(ByVal hWnd As Long, ByVal nMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

  'Window procedure for VB's MDIClient window

  Dim TopLn         As Long
  Dim NumLines      As Long
  Dim ScrollTo      As Long

    MDIClientProc = CallWindowProc(GetProp(hWnd, PropName), hWnd, nMsg, wParam, lParam)  'call the original winproc to do what has to be done
    With VBInstance
        Select Case nMsg 'and now split on message type
          Case WM_KILLFOCUS 'this codepane just lost the focus (remember - the original procedure has already been performed)
            UnhookCodePane
          Case WM_MDIACTIVATE, WM_SETFOCUS 'another codepane has been (re)activated by the user
            HookCodePane
          Case WM_MOUSEWHEEL 'hah! there it is, that's what it's all about - the user fingers the mouse wheel
            If wParam And 1 Then 'left mouse button is down while scrolling
                fSetOpts.Show vbModal 'show options dialog
                Unload fSetOpts
              Else 'NOT WPARAM...
                If Not .ActiveCodePane Is Nothing Then 'bug fix - we have a codepane to scroll in
                    With .ActiveCodePane
                        If .CodeModule.CountOfLines Then 'bug fix - codepane is not empty
                            'translate mousewheel and pressed key (Shift or Cntl)
                            TopLn = .TopLine
                            Select Case LinesToScroll
                              Case "-2"
                                NumLines = Int(.CountOfVisibleLines * ScrollFraction)
                              Case "-1"
                                NumLines = .CountOfVisibleLines - 1 'so that the bottom line is at the top after scrolling
                              Case Else
                                NumLines = Abs(Val(LinesToScroll))
                                If NumLines >= .CountOfVisibleLines Then 'not more than a page
                                    NumLines = .CountOfVisibleLines - 1
                                End If
                            End Select
                            ScrollTo = TopLn - Sgn(wParam) * NumLines / ((wParam And &HFFFF&) \ 4 + 1) 'compute new top line
                            If ScrollTo = TopLn Then
                                ScrollTo = TopLn - (Sgn(wParam) And Val(LinesToScroll) <> 0)
                            End If
                            With .CodeModule
                                Select Case ScrollTo 'correct it if it is out of range
                                  Case Is < 1
                                    ScrollTo = 1
                                  Case Is > .CountOfLines
                                    ScrollTo = .CountOfLines
                                End Select
                            End With '.CODEMODULE
                            If Smooth Then
                                Do
                                    TopLn = TopLn + Sgn(ScrollTo - TopLn)
                                    Sleep 1
                                    .TopLine = TopLn
                                Loop Until TopLn = ScrollTo
                              Else 'SMOOTH = FALSE/0
                                .TopLine = ScrollTo
                            End If
                        End If
                    End With '.ACTIVECODEPANE
                End If
            End If
        End Select
    End With 'VBINSTANCE

End Function

Private Sub RefreshMembers()

  'Copy all members to our own collection

  'This is necessary because VB apparently verifies and expands/compacts the current active line
  'thru access to it's Members collection. Originally this search was done in direct response to
  'the WM_CHAR message in the codepane proc, which resulted in the line being expanded/compacted
  'while typing. So now we build our own collection after VB has processed the current line anyway
  '(see CodePaneProc WM_KEYDOWN). Unfortunately this is quite a bit of an overhead, but it's mini-
  'mized because we only do it after the user really typed come code.

  Dim Compo         As VBComponent
  Dim Memb          As Member

    Set CodeMembers = New Collection
    For Each Compo In VBInstance.ActiveVBProject.VBComponents
        If Compo.Type <> vbext_ct_RelatedDocument And Compo.Type <> vbext_ct_ResFile Then
            For Each Memb In Compo.CodeModule.Members
                With Memb
                    If Len(.Name) > TriggerLength Then
                        CodeMembers.Add Array(Compo.Name, .Name, .Scope) 'arrayindex=0,1,2
                    End If
                End With 'MEMB
            Next Memb
        End If
    Next Compo

End Sub

Public Sub SendMeMail(FromhWnd As Long, Subject As String)

    If ShellExecute(FromhWnd, vbNullString, "mailto:UMGEDV@AOL.COM?subject=" & Subject & " &body=Hi Ulli,    .......    Best regards from ", vbNullString, App.Path, SW_SHOWNORMAL) < SE_NO_ERROR Then
        Beep
        MsgBox "Cannot send Mail from this System.", vbCritical, "Mail disabled/not installed"
    End If

End Sub

Private Sub UnhookCodePane()

    If hWndCodePane Then
        SetWindowLong hWndCodePane, IDX_WINDOWPROC, GetProp(hWndCodePane, PropName)
        RemoveProp hWndCodePane, PropName
        hWndCodePane = 0
    End If

End Sub

Public Sub UnhookMDIClient()

    If hWndMDIClient Then
        UnhookCodePane
        SetWindowLong hWndMDIClient, IDX_WINDOWPROC, GetProp(hWndMDIClient, PropName)
        RemoveProp hWndMDIClient, PropName 'remove the property
        hWndMDIClient = 0
    End If

End Sub

':) Ulli's VB Code Formatter V2.15.4 (03.10.2002 10:34:21) 89 + 471 = 560 Lines
